/******************************************************************************
 Copyright (c) 1997 G.J. Wijnands. All rights reserved.

 $Header:: /MewAddOn/Multi Edit/dfreg.sh 11    2-02-98 22:00 Gerard           $

******************************************************************************/

#define gsSESSIONNAME  Global_Str( "!Session_Name")

#define gsREGFLDROOT    "HKEY_CURRENT_USER\\Software\\Micro U.S. Nederland\\Multi-Edit AddOn\\"

// External registry values
#define gsREGVDFROOTDIRKEY "VDFRootDirKey"
#define gsREGWORKSPACESKEY "WorkSpacesKey"
#define gsREGMAINAPPKEY    "MainAppKey"

// Internal registry folders
#define gsREGFLDKEYWORDS   "Keywords"
#define gsREGFLDPROPERTIES "Properties"
#define gsREGFLDDEFAULT    "Defaults"
#define gsREGFLDLANGUAGES  "Languages\\"
#define gsREGFLDPROJECTS   "Projects\\"

// Internal registry values
#define gsREGDFPATH        "DFPath"
#define gsREGMAKEPATH      "MakePath"
#define gsREGDFPROG        "DFProg"
#define gsREGDFENV         "DFEnv"
#define gsREGHOME          "Home"
#define gsREGLANGUAGE      "Language"
#define gsREGSEARCHSTRING  "SearchString"
#define gsREGDEBUG         "Debug"
#define gsREGRUNTIME       "Runtime"
#define gsREGCOMPILER      "Compiler"
#define gsREGBUGCOMPILER   "BugCompiler"
#define gsREGDFSPY         "DFSpy"
#define gsREGRUNTIMEPARAMS "RuntimeParams"
#define gsREGNAME          "Name"
#define gsREGTYPE          "Type"

#define gsREGEXPLORER      "Explorer"
#define gsREGDFCOMP        "DFComp"
#define gsREGBUGDFCOMP     "BugDFComp"
#define gsREGDFPRECOMP     "DFPreComp"
#define gsREGDFFILE        "DFFile"
#define gsREGDFINDEX       "DFIndex"
#define gsREGDFMAINT       "DFMaint"
#define gsREGAPPBUILDER    "AppBuilder"
#define gsREGWORKSPACE     "Workspace"
#define gsREGMAINAPP       "MainApp"

#define gsREGINHERIT               "Inherit"
#define gsREGBDFENV                "bDFEnv"
#define gsREGBUSEPROGRAMPATH       "bUseProgramPath"
#define gsREGCONSTRUCTMATCHING     "ConstructMatching"
#define gsREGCLOSUREHIGHLIGHT      "ClosureHighlight"
#define gsREGAUTOUNINDENT          "AutoUnindent"
#define gsREGINDENTKEYWORDS        "IndentKeywords"
#define gsREGUNINDENTKEYWORDS      "UnindentKeywords"
#define gsREGSPECIALINDENTKEYWORDS "SpecialIndentKeywords"
#define gsREGAUTOEOLCOMMENT        "AutoEOLComment"
#define gsREGEOLCOMMENTHEADER      "EOLCommentHeader"
#define gsREGEOLHEADERWIDTH        "EOLHeaderWidth"
#define gsREGEOLAUTOFILLCOMMENT    "EOLAutoFillComment"
#define gsREGEOLAUTOFILLKEYWORDS   "EOLAutoFillKeywords"
#define gsREGEOLADJUSTCOMMENT      "EOLAdjustComment"
#define gsREGEOLADJUSTCOLUMN       "EOLAdjustColumn"
#define gsREGEOLAUTOFILLTAGS       "EOLAutoFillTags"
#define gsREGTAGKEYWORDS           "TagKeywords"
#define gsREGSEARCHPATH            "SearchPath"
#define gsREGDDSEARCHPATH          "DDSearchPath"
#define gsREGONLINEHELPFILE        "OnlineHelpfile"
#define gsREGONLINEHELPFILEKEY     "OnlineHelpfileKey"
#define gsREGROOTREGKEY            "RootRegKey"
#define gsREGMAINAPPSKIP           "MainAppSkip"

#define gsREGLANGUAGES "Languages"

#define giREGSUCCESS     0
#define giREGKEYNOTFOUND 2
#define giREGERROR_NO_MORE_ITEMS 259

prototype DFReg
{
  void CreateSubKey          ( str sSubKey );
  str  GetStringFromRegistry ( str sSubkey, str sKey );
  int  GetIntegerFromRegistry( str sSubkey, str sKey );
  void SetKeyFromRegistry    ( str sSubkey, str sKey, str sValue );
  void DeleteKeyFromRegistry ( str sSubkey, str sKey );
	
  str GetStringFromGlobalRegistry( str sKey );
  str GetSessionSettingRecursively( str sProject, str sKey );
      
  str GetSessionValue ( str sSession, str sKey );
  str GetLanguageValue( str sLanguage, str sKey );
  str GetStringSettingRecursively( str sKey );
  int GetIntegerSettingRecursively( str sKey );

  str GetSubkeys( str sKey, int bSorted, ... );

}

global 
		{
      int iRegError "!iRegError";       // Really an internal integer which contains the latest
                                        // error returned by an Registery function.
		}